#include <httplib.h>

namespace KiqServer {
using namespace httplib;

void handle_requests(Server& svr) {
  svr.Get("/hi", [](const Request& req, Response& res) {
    res.set_content("Hello World!", "text/plain");
  });

  svr.Get("/kiq", [](const Request& req, Response& res) {
    auto kiq_param = req.params.find("kiq");
    if (kiq_param != req.params.end() && kiq_param->second.size() > 0) {
      std::string return_string{"You passed the following parameter value: " +
                                kiq_param->second};
      LOG(INFO) << return_string;
      res.set_content(return_string, "text/plain");
    }
  });

  svr.Get(R"(/numbers/(\d+))", [&](const Request& req, Response& res) {
    auto numbers = req.matches[1];
    res.set_content(numbers, "text/plain");
  });

  svr.Get("/stop", [&](const Request& req, Response& res) { svr.stop(); });
}

void start_http_server() {
  Server svr;
  handle_requests(svr);
  svr.listen("localhost", 9820);
}
}  // namespace KiqServer

